package shapes

import "testing"

func TestPerimeter(t *testing.T) {
	rectangle := Rectangle{30.5, 20.5}
	got := rectangle.Perimeter()
	exp := 102.0

	if got != exp {
		t.Errorf("got %.2f expected %.2f", got, exp)
	}
}

func TestArea(t *testing.T) {
	checkArea := func(t testing.TB, shape Shape, exp float64) {
		t.Helper()
		got := shape.Area()

		if got != exp {
			t.Errorf("got %.2f expected %.2f", got, exp)
		}
	}

	t.Run("rectangles", func(t *testing.T) {
		rectangle := Rectangle{30.5, 20.5}
		exp := 625.25
		checkArea(t, rectangle, exp)
	})

	t.Run("circles", func(t *testing.T) {
		circle := Circle{10}
		exp := 314.1592653589793
		checkArea(t, circle, exp)
	})
}
